/**
 * @author Veikko Niemi
 * 			Jun 12, 2010, 1:16:44 PM
 */
package finnish;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import finnish.TextTransfer;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.math.MathContext;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Formatter;
import java.util.Locale;
import java.util.Properties;
import java.util.TimeZone;

/**
 * @author veikkoniemi Jun 12, 2010 1:16:44 PM
 */
public class FrLaskin extends JFrame {

/**
	 * 
	 */
	private static final long serialVersionUID_base = 2684204181296919352L;
	private static final long serialVersionUID = 23L + serialVersionUID_base; // 2.3 version

	/**
	 * Basic calculator by big numbers
	 */

	private static final int QUESTION_MESSAGE = 0;

	public FrLaskin(String otsikko) {
		super(otsikko);
		version = "v2.3";
		this.setLocation(600, 400); // vas, ylh
		this.setSize(450, 470); // leveys, korkeus
		naytto = this.getContentPane();
		naytto.setLayout(new FlowLayout());
		this.setTitle(programName + ": " + function + " (" + version + "_"
				+ language + ")");
		double number = 12345.678;
		NumberFormat defaultFormat = NumberFormat.getInstance();
		String defaultDecimalPoint = defaultFormat.format(number).substring(
				defaultFormat.format(number).indexOf("5") + 1,
				defaultFormat.format(number).indexOf("5") + 2);
		defaultDP = defaultDecimalPoint;
		Properties p = System.getProperties();
		String os = p.getProperty("os.name");
 		System.out.println(programName + ":" + ", serialVersionUID: "
 				+ serialVersionUID + ", " + version);
		System.out.println("Operating supervisor: " + os
				+ ", default decimalpoint: " + defaultDecimalPoint);
		if (os.contains("Mac"))
			teeNayttoMac();
		else
			teeNayttoWindows();

		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		// btOk.setDisplayedMnemonicIndex(0); // monesko merkki alleviivataan
		// btVersion.setMnemonic(KeyEvent.VK_V); // alt,"v" invokes dummy button
		// shows program version
		// btV.setMnemonic(KeyEvent.VK_V);
		// btYksi.setActionCommand("Version");
		// tfLuku.setToolTipText(txt0);
		btSumma.setToolTipText(txt1);
		btJako.setToolTipText(txt2);
		btV.setToolTipText(txt3);
		btPotenssi.setToolTipText(txt4);
		btClear.setToolTipText(txt6);
		btLopeta.setToolTipText(txt7);
		btLaske.setToolTipText(tip1);
		btVaihda.setToolTipText(tip2);
		cbMaxDecimals.setToolTipText(tip8);

		tfLuku.addActionListener(new AlsToiminta());
		btLiita.addActionListener(new AlsToiminta());
		btKopioi1.addActionListener(new AlsToiminta());
		btKopioi2.addActionListener(new AlsToiminta());
		btYksi.addActionListener(new AlsToiminta());
		btKaksi.addActionListener(new AlsToiminta());
		btKolme.addActionListener(new AlsToiminta());
		btNelja.addActionListener(new AlsToiminta());
		btViisi.addActionListener(new AlsToiminta());
		btKuusi.addActionListener(new AlsToiminta());
		btSeitseman.addActionListener(new AlsToiminta());
		btKahdeksan.addActionListener(new AlsToiminta());
		btYhdeksan.addActionListener(new AlsToiminta());
		btNolla.addActionListener(new AlsToiminta());
		btVaihda.addActionListener(new AlsToiminta());
		btDesim.addActionListener(new AlsToiminta());
		btSumma.addActionListener(new AlsToiminta());
		btTulo.addActionListener(new AlsToiminta());
		btJako.addActionListener(new AlsToiminta());
		btPotenssi.addActionListener(new AlsToiminta());
		cbMaxDecimals.addActionListener(new AlsToiminta());
		btLaske.addActionListener(new AlsToiminta());
		btClear.addActionListener(new AlsToiminta());
		btV.addActionListener(new AlsToiminta());
		btLopeta.addActionListener(new AlsToiminta());
		leikepoyta = new TextTransfer();
		cbMaxDecimals.setSelectedIndex(2);
		start(instruction);
	}

	private void start(String ohje) { // sovelluksen alkutoimet
		Date t = new Date();
		if (!ohje.isEmpty())
			ohje = "\n" + ohje;
		taLoki.setText(programName + "(" + version + "_" + language + ") "
				+ t.toString() + ohje);
		setSisaansyotto(true); // aloita luvun sisaansyotolla
		// setOperaatiot(false); // disabloi operaatiot
		pysyvaTarkkuus = false; // true, kun annettu laskutoimitarkkuus on
		// ohjelman ajan voimassa, ei kaytossa
		luku = BigInteger.ZERO;
		vastaus = BigInteger.ZERO;
		BigDecimal apu = BigDecimal.ZERO;
		dvastaus = apu.toString();
		dluku = dvastaus;
		// vastausSave = BigInteger.ZERO;
		// dvastausSave = BigDecimal.ZERO;
		// System.out.println("alkutoimet A: vastaus:" + vastaus.toString()
		// + ", dvastaus:" + dvastaus.toString());
		vastaukset = new ArrayList<String>();
		vastaukset.add(lastIndex); // indeksilla nolla on aina viimeisin vastaus
		engineering = false; // tfVastaus muoto on toEngineeringString() jos
		// true
		edellinenOperandi = 0; // aiheuttaa etta aluksi sijoitetaan vastauksiksi
		// eka luku
		vastausDesimaali = false;
		// vastausDesimaaliSave = vastausDesimaali;
		desimaali = false; // syotettava luku on BigInteger
		referOk = false; // ei ole viitattu edelliseen vastaukseen
		alku = true; // sovelluksen alku alkaa lokissa
		laskuja = 0; // Laske nappaimen vastausten valilla
		// uusiLaskutoimitusAlkaa = true; // true, alussa ja laske nappulan
		// painamisen jalkeen
		edellinen = emptyString;
		tfLuku.setText(emptyString);
		tfVastaus.setText(emptyString);
		yhteenveto = summary;
		tfLuku.requestFocus();
		nappaimet = true; // tiedon sisaansyottonappaimet kaytossa
		// System.out.println("alkutoimet: tfVastaus.getText(): "
		// + tfVastaus.getText());
		answering = false; // calc has not pushed
	}

	private void asetaLuku() {
		desimaali = false;
		boolean lukuOk = false;
		if (edellinenOperandi == 4) { // potenssiin korotus
			String apu = tfLuku.getText().trim();
			if (apu.contains(defaultDP)) {
				naytaVirheilmoitus(error1, header1);
				tfLuku.setText(edellinen);
				tfLuku.requestFocus();
				// System.out.println(out1 + edellinen);
			} else {
				lukuOk = lueLuku();
			}
		} else {
			lukuOk = lueLuku();
		}
		if (lukuOk) {
			setSisaansyotto(false);
			if (!operaatiot)
				setOperaatiot(true);
		} else {
			setOperaatiot(false);
		}
		// System.out.println("asetaLuku: lukuSyotetty: " + lukuSyotetty);
	}

	class AlsToiminta implements ActionListener {

		public void actionPerformed(ActionEvent painike) {

			if (painike.getSource() == tfLuku) {
				System.out.println("painike tfLuku painettu");
				asetaLuku();
			}
			if (painike.getSource() == btLiita) {
				tfLuku.setText(leikepoyta.getClipboardContents());
				asetaLuku();
			}
			if (painike.getSource() == btKopioi1) {
				leikepoyta.setClipboardContents(tfVastaus.getText());
			}
			if (painike.getSource() == btKopioi2) {
				leikepoyta.setClipboardContents(taLoki.getText());
			}
			if (painike.getSource() == btYksi) {
				tfLuku.setText(tfLuku.getText().trim() + one);
				lueLuku();
				if (!operaatiot)
					setOperaatiot(true);
			}
			if (painike.getSource() == btKaksi) {
				tfLuku.setText(tfLuku.getText().trim() + two);
				lueLuku();
				if (!operaatiot)
					setOperaatiot(true);
			}
			if (painike.getSource() == btKolme) {
				tfLuku.setText(tfLuku.getText().trim() + three);
				lueLuku();
				if (!operaatiot)
					setOperaatiot(true);
			}
			if (painike.getSource() == btNelja) {
				tfLuku.setText(tfLuku.getText().trim() + four);
				lueLuku();
				if (!operaatiot)
					setOperaatiot(true);
			}
			if (painike.getSource() == btViisi) {
				tfLuku.setText(tfLuku.getText().trim() + five);
				lueLuku();
				if (!operaatiot)
					setOperaatiot(true);
			}
			if (painike.getSource() == btKuusi) {
				tfLuku.setText(tfLuku.getText().trim() + six);
				lueLuku();
				if (!operaatiot)
					setOperaatiot(true);
			}
			if (painike.getSource() == btSeitseman) {
				tfLuku.setText(tfLuku.getText().trim() + seven);
				lueLuku();
				if (!operaatiot)
					setOperaatiot(true);
			}
			if (painike.getSource() == btKahdeksan) {
				tfLuku.setText(tfLuku.getText().trim() + eight);
				lueLuku();
				if (!operaatiot)
					setOperaatiot(true);
			}
			if (painike.getSource() == btYhdeksan) {
				tfLuku.setText(tfLuku.getText().trim() + nine);
				lueLuku();
				if (!operaatiot)
					setOperaatiot(true);
			}
			if (painike.getSource() == btNolla) {
				tfLuku.setText(tfLuku.getText().trim() + zero);
				lueLuku();
				if (!operaatiot)
					setOperaatiot(true);
			}
			if (painike.getSource() == btDesim) {
				btDesim.setEnabled(false); // ei useampaa desimaalimerkkia tahan
				// lukuun
				tfLuku.setText(tfLuku.getText().trim() + defaultDP);
				lueLuku();
			}

			if (painike.getSource() == btVaihda) {

				if (tfLuku.getText().isEmpty()) {
					tfLuku.setText(hyphen);
					BigDecimal help = BigDecimal.ZERO;
					dluku = help.toString();
					luku = BigInteger.ZERO;
				} else {
					if (tfLuku.getText().equals(hyphen)) {
						tfLuku.setText("");
					} else {
						BigDecimal md = new BigDecimal(minusOne);
						BigInteger m = new BigInteger(minusOne);
						if (desimaali) {
							// dluku = dluku.multiply(md);
							dluku = toDefaultDP(toJavaDP(dluku).multiply(md));
							tfLuku.setText(dluku.toString());
						} else {
							luku = luku.multiply(m);
							tfLuku.setText(luku.toString());
						}
					}
				}
				edellinen = tfLuku.getText().trim();
				// System.out.println("Luku: " + edellinen);
			}
			if (painike.getSource() == btSumma) {
				summa();
				if (!nappaimet)
					setSisaansyotto(true); // jos on painettu #V pitaa valita
				// toiminto seuraavaksi
			}
			if (painike.getSource() == btTulo) {
				tulo();
				if (!nappaimet)
					setSisaansyotto(true); // jos on painettu #V pitaa valita
				// toiminto seuraavaksi
			}
			if (painike.getSource() == btJako) {
				jako();
				if (!nappaimet)
					setSisaansyotto(true); // jos on painettu #V pitaa valita
				// toiminto seuraavaksi
			}
			if (painike.getSource() == btPotenssi) {
				potenssi();
				if (!nappaimet)
					setSisaansyotto(true); // jos on painettu #V pitaa valita
				// toiminto seuraavaksi
				btDesim.setEnabled(false); // seuraava potenssi pitaa olla
				// kokonaisluku
				btVaihda.setEnabled(false); // seuraava potenssi pitaa olla
				// positiivinen kokonaisluku
				// vaihto +/- nappain enabloidaan uusiOperandi metodissa, kun
				// edellinenOperandi == 4
				// ja desimaalimerkki aina kun tullaan uusiOperandi metodiin
			}

			if (painike.getSource() == cbMaxDecimals) {
				setMaxDecimals();
			}

			if (painike.getSource() == btLaske) {
				laske();
				if (!nappaimet)
					setSisaansyotto(true);
				// uusiLaskutoimitusAlkaa = true; // on true, alussa ja laske
				// painamisen jalkeen
			}
			if (painike.getSource() == btClear) {
				// if (edellinenOperandi != 0)laske();
				if (!nappaimet)
					setSisaansyotto(true);
				/*
				 * Date t = new Date(); taLoki.setText(programName + ":" +
				 * t.toString()); desimaali = false; vastausDesimaali = false;
				 * tfLuku.setText(""); tfVastaus.setText("");
				 * tfLuku.requestFocus(); //
				 * System.out.println("btClear kuuntelija: tfVastaus.getText(): "
				 * // + tfVastaus.getText());
				 */
				start("");
			}
			if (painike.getSource() == btV) {
				vastaukset();
				if (!nappaimet)
					setSisaansyotto(true);
				// System.out.println("painike btV loppuu: tfLuku:"
				// + tfLuku.getText() + " tfVastaus:"
				// + tfVastaus.getText() + " edellinen:" + edellinen);
			}
			if (painike.getSource() == btLopeta) {
				int vastaus = JOptionPane.showConfirmDialog(naytto, txt8);
				switch (vastaus) {
				case JOptionPane.NO_OPTION:
					leikepoyta.setClipboardContents(emptyString);
					System.out.println(txt9);
					System.exit(0);
				case JOptionPane.YES_OPTION:
					String lokiS = taLoki.getText();
					leikepoyta.setClipboardContents(lokiS); // viimeisin tilanne
					// myšs
					// lopetushetkella
					System.out.println(txt10);
					System.exit(0);
				case JOptionPane.CLOSED_OPTION:
				case JOptionPane.CANCEL_OPTION:
					System.out.println(txt11);
					if (!nappaimet)
						setSisaansyotto(true);
					start("");
				}

			}

			// if (painike.getActionCommand().equals("Version")){
			// System.out.println(programName + serialVersionUID);
			// }
		}
	}

	private void trace() {
		try {
			Integer.parseInt("a"); // make abort with trace
		} catch (Exception s) {
			s.printStackTrace();
		}
	}

	private void naytaVirheilmoitus(String virheilmoitus, String otsikko) {
		JOptionPane.showMessageDialog(naytto, virheilmoitus, otsikko,
				JOptionPane.INFORMATION_MESSAGE);
//		trace();
	}

	private boolean lueLuku() {
		/**
		 * Jos edellinen operandi on potenssiin korotus ja nappaillaan
		 * desimaalimerkki ei tulla tanne, muuten kaikissa muissa tapauksissa
		 * eli Kun on nappailty joku 0 - 9, "." tai "-" tai syotetty kenttaan
		 * tfLuku ja painettu enter, tullaan tanne. Tarkistetaan luku ja
		 * annetaan tarvittaessa virheilmoitus, talloin palautetaan edellinen
		 * luku tfLuku kentan arvoksi. Kun poistutaan, on desimaali true ja
		 * negatiivinen true vastaavissa luvun tapauksissa ok luku siirretaan
		 * edelliseksi ja luku/dluku on paivitetty uudella Big-luvulla
		 */
		boolean palauta = false;
		boolean powError = false;
		String l = emptyString;
		try {
			l = tfLuku.getText().trim();
//			System.out.println("\nLuku: " + l
//					+ " ********************************* luku sisaan");
			// System.out.println("lueLuku a: tfLuku: " + tfLuku.getText()
			// + " luku:" + luku.toString() + " dluku:" + dluku.toString()
			// + " tfVastaus:" + tfVastaus.getText());
			// System.out.println("lueLuku b: desimaali:" + desimaali
			// + " vastausDesimaali:" + vastausDesimaali);
			if (l.isEmpty() || l.equals(minusSign)) {
				luku = BigInteger.ZERO;
				desimaali = false;
			} else {
				// if (l.substring(0, 1).equals(minusSign)) {
				// System.out.println("lueLuku bb: tfLuku: "
				// + tfLuku.getText() + " luku:" + luku.toString());
				// }
				// System.out.println("lueLuku c:");
				if (l.equals(defaultDP) || l.equals(minusSign + defaultDP)) { // pelkka
					// desimaalipiste
					// ./-.
					// ohitetaan
					desimaali = true; // tama luku on desimaaliluku
					// System.out.println("lueLuku d: tfLuku: " +
					// tfLuku.getText()
					// + " luku:" + luku.toString());
					if (edellinenOperandi == 4) { // ellei potenssi operaatio
						naytaVirheilmoitus(error2, header2);
						tfLuku.setText(edellinen);
						tfLuku.requestFocus();
						l = edellinen;
						// System.out.println("Palautettu luku: " + edellinen);
					}
				} else { // ylla ohitetaan myos "-."
					// System.out.println("lueLuku e: tfLuku: " +
					// tfLuku.getText()
					// + " luku:" + luku.toString());
					if (edellinenOperandi == 4) { // potenssin suuruus
						// rajoitettu, (on syotetty suoraan tfLuku enter
						// kentasta)
//						System.out
//								.println("lueLuku f: tfLuku: "
//										+ tfLuku.getText() + " luku:"
//										+ luku.toString());
						powError = true;
						int apu = Integer.parseInt(l); // may cause an error
						powError = false;
//						System.out.println("lueLuku f1: apu: " + apu);
						if (apu > -1 && apu < 1000000000) { // ok
							// System.out.println("lueLuku g: tfLuku: "
							// + tfLuku.getText() + " luku:"
							// + luku.toString());
						} else {
							naytaVirheilmoitus(error3, header3);
							tfLuku.setText(edellinen);
							tfLuku.requestFocus();
							l = edellinen;
							// System.out.println("lueLuku h: Palautettu luku: "
							// + edellinen);
						}
					}
					desimaali = false;
					if (l.contains(defaultDP)) {
						// dluku = new BigDecimal(tfLuku.getText().trim());
						dluku = tfLuku.getText().trim();
						// System.out.println("lueLuku i: tfLuku: "
						// + tfLuku.getText() + " dluku:"
						// + dluku.toString());
						desimaali = true;
					} else {
						// System.out
						// .println("lueLuku j: tfLuku: "
						// + tfLuku.getText() + " luku:"
						// + luku.toString());
						luku = new BigInteger(tfLuku.getText().trim());
					}
				}
			}
			lukuSyotetty = true; // testataan uusiOperandi()
			// System.out.println("lueLuku k: tfLuku: " + tfLuku.getText()
			// + " luku:" + luku.toString());
			edellinen = l; // luvun luku ok, siirretaan edelliseksi
			// System.out.println("lueLuku l: tfLuku: " + tfLuku.getText()
			// + " luku:" + luku.toString());
			setOperaatiot(true);
			if (desimaali) {
				btDesim.setEnabled(false); // ala salli useampia merkkeja tassa
			}

			// luvussa
			// System.out.println("lueLuku p: tfLuku: " + tfLuku.getText()
			// + " luku:" + luku.toString() + " dluku:" + dluku.toString()
			// + " tfVastaus:" + tfVastaus.getText());
			// System.out.println("lueLuku q: desimaali:" + desimaali
			// + " vastausDesimaali:" + vastausDesimaali);
			String lukuString = emptyString;
			try {
				String apu = tfLuku.getText().trim();
				if (!apu.isEmpty() && !apu.contains(defaultDP)
						&& edellinenOperandi == 4) {
//					System.out.println("lueLuku: testing pow: "
//							+ tfLuku.getText());
					pow = Integer.parseInt(tfLuku.getText()); // valmiiksi
					// potenssilaskua
					// varten

				}
				palauta = true;
				// System.out.println("lueLuku: pow =" + pow +
				// " edellinenOperandi:" + edellinenOperandi + " apu:" + apu);
				return palauta;
			} catch (Exception e) {
				String virheteksti = error4 + lukuString;
				System.out.println(virheteksti);
				naytaVirheilmoitus(virheteksti, errorHeading);
				tfLuku.setText(edellinen);
				return palauta;
			}
		} catch (NumberFormatException nfe) {
			String virheteksti = error5 + l;
			if (powError)
				virheteksti = errorPow + l;
			System.out.println(virheteksti);
			// nfe.printStackTrace();
			naytaVirheilmoitus(virheteksti, errorHeading);
			tfLuku.setText(edellinen);
			return palauta;
		} catch (Exception e) {
			String virheteksti = error6 + l;
			System.out.println(virheteksti);
			// e.printStackTrace();
			naytaVirheilmoitus(virheteksti, errorHeading);
			tfLuku.setText(edellinen);
			return palauta;
		}
	}

	private void summa() {
		// System.out.println(tfLuku.getText() + "\n      +");
		uusiOperandi(" + ");
		lukuSyotetty = false;
		// desimaali = false;
		setSisaansyotto(true);
		edellinenOperandi = 1; // nyt summa muuttuu edelliseksi
	}

	private void tulo() {
		// System.out.println("\n      *");
		uusiOperandi(" * ");
		lukuSyotetty = false;
		// desimaali = false;
		setSisaansyotto(true);
		edellinenOperandi = 2; // nyt tulo muuttuu edelliseksi
	}

	private void jako() {
		// System.out.println("\n      /");
		uusiOperandi(" / ");
		lukuSyotetty = false;
		// desimaali = false;
		setSisaansyotto(true);
		edellinenOperandi = 3; // nyt jako muuttuu edelliseksi
	}

	private void potenssi() {
		// System.out.println("\n      ^");
		uusiOperandi(" ^ ");
		lukuSyotetty = false;
		// desimaali = false;
		setSisaansyotto(true);
		edellinenOperandi = 4; // nyt potenssi muuttuu edelliseksi
	}

	private void setMaxDecimals() {
		maxDecimals = (String) cbMaxDecimals.getSelectedItem();
		System.out.println("setMaxDecimals: maxDecimals: " + maxDecimals);
	}

	private void laske() {

		uusiOperandi(yhteenveto);
		answering = true;
		setSisaansyotto(true);
		lukuSyotetty = false;
		edellinenOperandi = 0;
		// System.out.println("\nlaske: vastausDesimaali: " + vastausDesimaali);
		// String apu1 = vastaus.toString();
		// if (vastausDesimaali)
		// apu1 = finalizeDecimalAnswer(dvastaus);
		if (laskuja == 0) {
			// painettu perakkain laske-nappulaa
			if (vastausDesimaali) {
				tfVastaus.setText(dvastaus);
			} else
				tfVastaus.setText(vastaus.toString());
		}
		// System.out
		// .println("laske: tfVastaus.getText(): " + tfVastaus.getText());
		String v = tfVastaus.getText();
		String apu1 = naytaIsotLuvut(v, isoLukuLoki, loki);
		v = tfVastaus.getText();
		String lokiS = taLoki.getText();
		vastaukset.set(0, v); // viimeisin vastaus on aina myos V#0
		vastaukset.add(v);
		String vastausString = answer + (vastaukset.size() - 1) + colon + apu1; // V#
		taLoki.setText(lokiS + vastausString + "\n");
		apu1 = naytaIsotLuvut(v, isoLukuSystem, system);
		vastausString = answer + (vastaukset.size() - 1) + colon + apu1; // V#
		System.out.println(yhteenveto + vastausString + yhteenveto);
		// edellinenOperandi = 0;
		tfLuku.setText("");

		// System.out
		// .println("laske: tfVastaus.getText(): " + tfVastaus.getText());
		// System.out.println("laske 2: vastausSave:" + vastausSave.toString()
		// + ", dvastausSave:" + dvastausSave.toString());
		laskuja = 0;
		answering = false;
	}

	private void vastaukset() {

		// System.out.println("vastaukset:tfLuku.getText():" + tfLuku.getText()
		// + ", edellinen:" + edellinen);
		edellinen = tfLuku.getText(); // Lisatty ke 23.6
		if (palautaVastaus()) {
			laskuja++; // lisatty 28.6.
			// uusiLaskutoimitusAlkaa = true;
			// System.out.println("vastaukset:save:" + save
			// + ", tfLuku.getText():" + tfLuku.getText());
			String lokiS = taLoki.getText().trim();
			String apu = luku.toString();
			if (desimaali)
				apu = dluku.toString();
			// System.out.println("vastaukset: apu:" + apu + " luku:" + luku
			// + " dluku:" + dluku);
			String apu1 = naytaIsotLuvut(apu, isoLukuLoki, loki);
			// taLoki.setText(loki + answer1 + edellinen + colon + apu +
			// backSlashN); // "   V#"
			// taLoki.setText(loki + answer1 + edellinen + colon + apu1 +
			// backSlashN); // "  answer1 is V#"
			// taLoki.setText(lokiS + answer1 + edellinen + colon + apu1 +
			// backSlashN); // "  answer1 is V#"
			taLoki.setText(lokiS + answer1 + vastausInd + colon + apu1
					+ backSlashN); // "  answer1 is V#"
			// korjattu
			// 28.6.
			// System.out.println("vastaukset: edellinen:" + edellinen);
			apu1 = naytaIsotLuvut(apu, isoLukuSystem, system);
			// System.out.println(answer1 + tfLuku.getText() + ":" + apu1);
			// System.out.println(answer1 + vastausInd + ":" + apu1); //
			// korjattu 28.6.
			// System.out.println("vastaukset: Hep2");
			vastausInd = "";
			setSisaansyotto(false); // vaaditaan operandia seuraavaksi
		} else {
			tfLuku.setText(emptyString); // tyhjenna vastaus
			String ilmoitus = txt12;
			naytaVirheilmoitus(ilmoitus, errorHeading);
			System.out.println(ilmoitus);
			setSisaansyotto(true);
			setOperaatiot(false);
		}

	}

	private boolean palautaVastaus() {
		/**
		 * Kutsutaan kun on painettu #V nappainta vastaukset() metodista
		 * palauttaa viimeisimmaksi luvuksi vastauksen numerolla #V
		 */
		referOk = false;
		boolean hyvaPotenssi = true; // jos edellinenOperandi == 4 ja palautettu
		// luku kokonaisluku 0-999999999
		vastausInd = tfLuku.getText();
		if (vastausInd.isEmpty()) { // default index zero
			vastausInd = "0";
		}
		String apu = "";
		int i = -1;
		try {
			// System.out.println("palautaVastaus:indeksi vastausInd:" +
			// vastausInd
			// + ", tfLuku.getText():" + tfLuku.getText());
			i = Integer.parseInt(vastausInd);
		} catch (Exception e) {
			e.printStackTrace();
		}
		if (i > -1 && i < vastaukset.size()) { // indeksi ok
			apu = vastaukset.get(i).trim();
			if (apu.contains(infinity)) { // sanasta infinity=aareton
				String virheteksti = error7;
				naytaVirheilmoitus(virheteksti, errorHeading);
				System.out.println(virheteksti);
				if (!nappaimet)
					setSisaansyotto(true);
			} else {
				System.out.println("palautaVastaus1: apu:" + apu
						+ " edellinenOperandi: " + edellinenOperandi);
				if (apu.contains(defaultDP)) { // potenssi pitaa olla >= 0

					if (edellinenOperandi != 4) {
						// vastausDesimaali = true;
						desimaali = true;
						// dluku = new BigDecimal(apu);
						dluku = apu;
						referOk = true;
					} else
						hyvaPotenssi = false;
					if (!vastausDesimaali && hyvaPotenssi) {
						dvastaus = vastaus.toString();
					}
				} else {
					if (edellinenOperandi == 4 && apu.length() > 9) {
						hyvaPotenssi = false; // liian iso potenssi
						System.out.println("palautaVastaus2: apu:" + apu);
					} else {
						// if (laskuja == 0) { // laske operaatio edellinen
						// System.out.println("palautaVastaus:  vastausDesimaali: "
						// + vastausDesimaali);
						// vastausDesimaali = false; // nyt voi seurata
						// kokonaisluku
						// vastaus
						// }
						desimaali = false;
						luku = new BigInteger(apu);
						referOk = true;
					}
				}
				System.out.println("palautaVastaus: hyvaPotenssi: "
						+ hyvaPotenssi + " referOk: " + referOk);
				if (!hyvaPotenssi)
					return referOk;
				tfLuku.setText(apu);
				tfVastaus.setText(apu);
				// System.out.println("palautaVastaus: apu:" + apu);
				// if (!apu.substring(0, 1).equals(minusSign))
				// edellinen = apu;
			}
			// System.out.println("palautaVastaus: palautettu luku:" + apu
			// + ", tfLuku.getText():" + tfLuku.getText());
		}
		lueLuku(); // lisatty 28.6.
		// System.out.println("palautaVastaus: tfVastaus.getText(): "
		// + tfVastaus.getText() + " vastausDesimaali:" + vastausDesimaali
		// + " desimaali:" + desimaali);
		return referOk;
	}

	private void setSisaansyotto(boolean tila) {
		/**
		 * nappaimet poistetaan kun on valittu #V, joka vaatii seuraavaksi
		 * operaatiota nappaimet enabloidaan summa,tulo,jako,potenssi,laske ja
		 * lopeta() metodeissa
		 */

		btYksi.setEnabled(tila);
		btKaksi.setEnabled(tila);
		btKolme.setEnabled(tila);
		btNelja.setEnabled(tila);
		btViisi.setEnabled(tila);
		btKuusi.setEnabled(tila);
		btSeitseman.setEnabled(tila);
		btKahdeksan.setEnabled(tila);
		btYhdeksan.setEnabled(tila);
		btNolla.setEnabled(tila);
		btVaihda.setEnabled(tila);
		btDesim.setEnabled(tila);
		tfLuku.setEnabled(tila);
		btV.setEnabled(tila);
		btLiita.setEnabled(tila);
		// sisaansyotto = tila;
	}

	private void setOperaatiot(boolean tila) {
		btSumma.setEnabled(tila);
		btTulo.setEnabled(tila);
		btJako.setEnabled(tila);
		btPotenssi.setEnabled(tila);
		btLaske.setEnabled(tila);
		operaatiot = tila;
	}

	private void kysyLaskutoimitustenTarkkuus() {
		// this method is not yet ready and not used
		if (!pysyvaTarkkuus) {
			if (vastausDesimaali) {
				boolean kysy = true;
				while (kysy) {
					String vastaus = JOptionPane.showInputDialog(naytto,
							question1, question1Heading, QUESTION_MESSAGE);
					try {
						int desimaalienMaxLkmVastauksessa = Integer
								.parseInt(vastaus);
						kysy = false;
						if (desimaalienMaxLkmVastauksessa < 0) {
							pysyvaTarkkuus = true;
							desimaalienMaxLkmVastauksessa *= -1;
						}
						// dvastaus.setScale(desimaalienMaxLkmVastauksessa,
						// BigDecimal.ROUND_HALF_UP); // taa scale ei
						// rajoita
						// desimaaleja
						BigDecimal help = new BigDecimal(dvastaus);
						dvastaus = help.setScale(desimaalienMaxLkmVastauksessa,
								BigDecimal.ROUND_HALF_UP).toString(); // taa
						// scale
						// ei
						// rajoita
						// desimaaleja

					} catch (Exception e) {
						System.out.println(out2 + vastaus);
					}
				}
			}
		}
	}

	private boolean tarkistaEdellinenLuku() {
		boolean tila = false; // luku virheellinen
		try {

			// System.out.println("1 '" + luku + "'" + " '" + toJavaDP(dluku) +
			// "' ");
			BigDecimal apu = new BigDecimal(luku);
			// System.out.println("2 '" + luku + "'" + " '" + toJavaDP(dluku) +
			// "' " + apu);
			// apu = dluku.add(apu);
			apu = toJavaDP(dluku).add(apu);
			tila = true;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return tila;
	}

	private void toistaLokiin(String operandi) {
		String lokiS = taLoki.getText().trim();
		// String lukuString = luku.toString();
		String toista = "";
		// System.out.println("toistaLokiin: lukuSyotetty: " + lukuSyotetty +
		// " desimaali: " + desimaali + " alku: " + alku);
		String txt = "";
		if (!lukuSyotetty) {
			if (tfLuku.getText().isEmpty()) {
				if (desimaali) {
					toista = naytaIsotLuvut(dluku.toString(), isoLukuLoki, loki);
				} else {
					toista = naytaIsotLuvut(luku.toString(), isoLukuLoki, loki);
				}
			} else { // new number without sending it by enter in tfLuku
				asetaLuku();
				txt = naytaIsotLuvut(tfLuku.getText(), isoLukuLoki, loki);
			}
		} else {
			if (referOk) { // already in log
				txt = "";
				referOk = false;
			} else {
				txt = naytaIsotLuvut(tfLuku.getText(), isoLukuLoki, loki);
				// dont know if it comes never here!
			}
		}

		if (toista.contains(dataline))
			toista = backSlashN + toista; // start new line when long answer
		if (txt.contains(dataline))
			txt = backSlashN + txt; // start new line when long answer

		// System.out.println("toistaLokiin: " + operandi + " " +
		// edellinenOperandi + " " + desimaali + " " + luku);
		if (alku) {
			alku = false;
			taLoki.setText(lokiS + backSlashN + txt + toista + operandi);
			if (operandi.equals(yhteenveto)) {
				if (desimaali) {
					System.out.print(dluku);
				} else
					System.out.print(luku);
			}
		} else {
			// System.out.println("edellinen:'" + edellinen + "'");
			if (operandi.equals(yhteenveto)) {
				String rivi = backSlashN;
				if (txt.isEmpty())
					rivi = emptyString;
				taLoki.setText(lokiS + rivi + txt + toista + operandi);
				// System.out.println("toistaLokiin: edellinenOperandi:" +
				// edellinenOperandi);
				if (edellinenOperandi == 0) {
					if (desimaali) {
						System.out.print(dluku);
					} else
						System.out.print(luku);
				}
			} else {
				taLoki.setText(lokiS + yhteenveto + txt + toista + operandi);
			}
			String r = space;
			if (laskuja == 0 && edellinenOperandi == 0)
				r = backSlashN;
			taLoki.setText(lokiS + r + txt + toista + operandi);
		}
	}

	private void uusiOperandi(String operandi) { // uuden operandin toimet
		/**
		 * Tanne tullan kun on nappailty joku operaationappain (Laske,+,*,/,^)
		 * edellinenOperandi ilmoittaa mika operaatio nyt pitaa suorittaa jos se
		 * on nolla, on edellisella kerralla tanne tullessa tehty Laske
		 * operaatio eli yhteenveto Jos edellinen luku on ollut desimaaliluku on
		 * ainakin koko vastaus desimaaliluku desimaali = true laitetaan paalle
		 * lueLuku metodissa vastausDesimaali saa arvon false palautaVastaus ja
		 * tassa metodissa lukuSyotetty = true, kun on syotetty luku
		 * operaatioiden valilla Jos ketjun edellinen vastaus on desimaaliluku
		 * lasketaan esim. yhteen dvastaus + luku, jos desimaali = false tai
		 * dvastaus + dluku, jos desimaali = true Jos ketjun edellinen vastaus
		 * ei ole desimaalinen lasketaan esim yhteen vastaus + luku, jos
		 * desimaali = false tai vastaus + dluku, jos desimaali on true
		 */
		// System.out.println("uusiOperandi(alussa): vastausDesimaali:"
		// + vastausDesimaali + ", desimaali:" + desimaali);
		if (edellinenOperandi == 4) {
			// potenssi saatu, vapauta desim ja +/- nappain
			// btDesim.setEnabled(true);
			btVaihda.setEnabled(true);
		}
		btDesim.setEnabled(true); // luku saatu, vapauta desimaalipiste
		// laittettu pois kun saatu ensimmainen desimaalimerkki
		String laskutoimitus = emptyString;
		if (tarkistaEdellinenLuku()) {
			// System.out.println("uusiOperandi A: vastaus:" +
			// vastaus.toString()
			// + ", dvastaus:" + dvastaus.toString());
			// kysyLaskutoimitustenTarkkuus();
			toistaLokiin(operandi);
			// System.out.println(" Edellinen operandi: " + edellinenOperandi);
			// System.out
			// .println("******************************** uusiOperandi: laskuja:"
			// + laskuja);
			// System.out.println("luku:" + luku + " dluku:" + dluku);
			// System.out.println("1vastaus:" + vastaus + " dvastaus:" +
			// dvastaus);
			// System.out.println("uusiOperandi: desimaali: " + desimaali
			// + " vastausDesimaali:" +
			// vastausDesimaali);
			switch (edellinenOperandi) {
			case 0: // alkutoimet ennen ensimmaista suoritettavaa operandia
				/**
				 * 1) Kayttaja on syottanyt luvun ja painanut operaatiota, niin
				 * tullaan tahan, laskuja = 0 2) kayttaja painanut laske, on
				 * suoritettu lasku (+,*,/,^), annettu edelliseksi operaatioksi
				 * 0 ja seuraavalla kerralla kun on syotetty luku ja painettu
				 * jokin operaatio tullaan tahan
				 */
				// System.out.println("uusiOperandi: case 0: laskuja: " +
				// laskuja);
				// if (laskuja == 0 && lukuSyotetty) {
				if (laskuja < 2) { // is one when calling previous answer as
									// first operator
				// if (laskuja ==
				// 0)System.out.println("edellinenOperandi: ****************************************** zero");
				// if (laskuja ==
				// 1)System.out.println("edellinenOperandi: ****************************************** "
				// + vastaus + " " + dvastaus);
					// System.out.println("uusiOperandi: case 0: vastausDesimaaliSave:"
					// + vastausDesimaaliSave);
					vastaus = luku;
					dvastaus = dluku;
					// System.out.println("uusiOperandi: desimaali: " +
					// desimaali + ", vastausDesimaali: " + vastausDesimaali);
					vastausDesimaali = desimaali;
					if (desimaali) {
						tfVastaus.setText(dvastaus);
					} else
						tfVastaus.setText(vastaus.toString());
				} else { // operandi kohdistuu edelliseen vastaukseen
					System.out.println("uusiOperandi: case 0: laskuja: "
							+ laskuja);
					luku = vastaus;
					dluku = dvastaus;
					desimaali = vastausDesimaali;
				}

				// System.out.println("uusiOperandi B: vastaus:"
				// + vastaus.toString() + ", dvastaus:"
				// + dvastaus.toString());
				// System.out.println("uusiOperandi:0: tfVastaus.getText(): "
				// + tfVastaus.getText());
				break;

			case 1: // summa
				if (vastausDesimaali) {
					if (!desimaali) {
						// String lukuString = luku.toString(10) + defaultDP;
						String lukuString = luku.toString() + defaultDP;
						// dluku = new BigDecimal(lukuString);
						dluku = lukuString;
						desimaali = true;
					}
					System.out.print(dvastaus + addOperator + dluku);
					// dvastaus = dvastaus.add(dluku);
					dvastaus = toDefaultDP(toJavaDP(dvastaus).add(
							toJavaDP(dluku)));
					System.out.println(equalSign + dvastaus);
				} else {
					if (desimaali) {
						// System.out.println("uusiOperandi:case 1: vastaus:"
						// + vastaus);
						// dvastaus = new BigDecimal(vastaus);
						dvastaus = toDefaultDP(vastaus);
						vastausDesimaali = true;
						System.out.print(dvastaus + addOperator + dluku);
						// dvastaus = dvastaus.add(dluku);
						dvastaus = toDefaultDP(toJavaDP(dvastaus).add(
								toJavaDP(dluku)));
						System.out.println(equalSign + dvastaus);
					} else {
						System.out.print(vastaus + addOperator + luku);
						vastaus = vastaus.add(luku);
						System.out.println(equalSign + vastaus);
					}
				}
				if (vastausDesimaali) {
					// tfVastaus.setText(muotoileDesimaali(dvastaus));
					tfVastaus.setText(muotoileDesimaali(toJavaDP(dvastaus)));
				} else
					tfVastaus.setText(vastaus.toString());
				// System.out.println("uusiOperandi:1: tfVastaus.getText(): "
				// + tfVastaus.getText());
				break;
			case 2: // tulo
				if (vastausDesimaali) {
					if (!desimaali) {
						String lukuString = luku.toString(10) + defaultDP;
						// dluku = new BigDecimal(lukuString);
						dluku = lukuString;
						desimaali = true;
					}
					System.out.print(dvastaus.toString()
							+ multiplicationOperator + dluku.toString());
					// dvastaus = dvastaus.multiply(dluku);
					dvastaus = toDefaultDP(toJavaDP(dvastaus).multiply(
							toJavaDP(dluku)));
					System.out.println(equalSign + dvastaus.toString());
				} else {
					if (desimaali) {
						String vastausString = vastaus.toString() + ".";
						// dvastaus = new BigDecimal(vastausString);
						dvastaus = vastausString;
						vastausDesimaali = true;
						System.out.print(dvastaus + multiplicationOperator
								+ dluku);
						// dvastaus = dvastaus.multiply(dluku);
						dvastaus = toDefaultDP(toJavaDP(dvastaus).multiply(
								toJavaDP(dluku)));
						System.out.println(equalSign + dvastaus);
					} else {
						System.out.print(vastaus + multiplicationOperator
								+ luku);
						vastaus = vastaus.multiply(luku);
						System.out.println(equalSign + vastaus);
					}
				}
				if (vastausDesimaali) {
					// tfVastaus.setText(muotoileDesimaali(dvastaus));
					tfVastaus.setText(muotoileDesimaali(toJavaDP(dvastaus)));
				} else
					tfVastaus.setText(vastaus.toString());
				// System.out.println("uusiOperandi:2: tfVastaus.getText(): "
				// + tfVastaus.getText());
				break;
			case 3: // jako
				
				// System.out.println(vastausDesimaali + " " + desimaali + " " +
				// dluku + " " + luku);
				try {
					if (vastausDesimaali) {

						if (!desimaali) {
							dluku = toDefaultDP(luku);
							desimaali = true;
						}
						laskutoimitus = dvastaus + dividationOperator + dluku;
						// dvastaus = dvastaus.divide(dluku, DECIMAL128);
						dvastaus = toDefaultDP(toJavaDP(dvastaus).divide(
								toJavaDP(dluku), DECIMAL128));
						System.out
								.println(laskutoimitus + equalSign + dvastaus);
						// String vastausString = muotoileDesimaali(dvastaus);
						String vastausString = muotoileDesimaali(toJavaDP(dvastaus));
						tfVastaus.setText(vastausString);
					} else {

						vastausDesimaali = true;
						if (desimaali) {

							laskutoimitus = vastaus + dividationOperator
									+ dluku;
							// dvastaus = vastaus.divide(dluku, DECIMAL128);

						} else {
							// dvastaus = new BigDecimal(vastaus);
							// dluku = new BigDecimal(luku);
							dluku = toDefaultDP(luku);
							laskutoimitus = vastaus + dividationOperator + luku;
						}
						dvastaus = toDefaultDP(vastaus);
						// dvastaus = dvastaus.divide(dluku, DECIMAL128); // max
						// 34 desimaalia
						dvastaus = toDefaultDP(toJavaDP(dvastaus).divide(
								toJavaDP(dluku), DECIMAL128));
						System.out
								.println(laskutoimitus + equalSign + dvastaus);
						String vastausString = muotoileDesimaali(toJavaDP(dvastaus));
						tfVastaus.setText(vastausString);
					}
					// System.out.println("uusiOperandi:3: tfVastaus.getText(): "
					// + tfVastaus.getText());
				} catch (java.lang.ArithmeticException ae) {
					String virheteksti = backSlashN + error8 + backSlashN
							+ error8Plus;
					virheteksti = laskutoimitus + virheteksti;
					System.out.println(virheteksti);
					vastaus = BigInteger.ZERO;
					// dvastaus = BigDecimal.ZERO;
					BigDecimal help = BigDecimal.ZERO;
					dvastaus = toDefaultDP(help);
					tfVastaus.setText("infinity");
					naytaVirheilmoitus(virheteksti, errorHeading);
				}

				break;
			case 4: // potenssi
				// tanne tultaessa pitaa huolehtia, etta pow on kokonaisluku
//				boolean start = true;				
				try {
				if (vastausDesimaali) {
						laskutoimitus = dvastaus + powOperator + pow;
					System.out.print(dvastaus + powOperator + pow);
					// dvastaus = dvastaus.pow(pow);
//					elapsedTime(start);
						dvastaus = toDefaultDP(toJavaDP(dvastaus).pow(pow));
//						start = false;
//					elapsedTime(start);
					System.out.println(equalSign + dvastaus);
					// String vastausString = muotoileDesimaali(dvastaus);
					String vastausString = muotoileDesimaali(toJavaDP(dvastaus));
					tfVastaus.setText(vastausString);
					// System.out
					// .println("case 4: tfVastaus:"
					// + tfVastaus.getText()
					// + " **************************************************");
				} else {
					// kokonaisluku vastaus
					dluku = toDefaultDP(luku);
					laskutoimitus = vastaus + powOperator + pow;
					System.out.print(vastaus + powOperator + pow);
					
//					elapsedTime(start);
					
					vastaus = vastaus.pow(pow);
												
// 					start = false;
// 					elapsedTime(start);
					System.out.println(equalSign + vastaus);
					tfVastaus.setText(vastaus.toString());
				}
				// System.out.println("uusiOperandi:4: tfVastaus.getText(): "
				// + tfVastaus.getText());
				} catch (ArithmeticException ae) {
					String virheteksti = backSlashN + errorPow2
							+ backSlashN + errorPowPlus2;
					virheteksti = laskutoimitus + virheteksti;
					System.out.println(virheteksti);
					// vastaus = BigInteger.ZERO;
					// dvastaus = BigDecimal.ZERO.toString();
					BigDecimal help = BigDecimal.ZERO;
					dvastaus = toDefaultDP(help);
					tfVastaus.setText("infinity");
					naytaVirheilmoitus(virheteksti, errorHeading);
				}
				break;
			default:
				System.out.println(error9 + edellinenOperandi);
			}
			// uusiLaskutoimitusAlkaa = false; // ei enaa ketjun eka
			// laskutoimitus
			if (edellinenOperandi != 0)
				laskuja++;
			// System.out
			// .println("**************** uusiOperandi(lopussa): laskuja:"
			// + laskuja);

			String txt = naytaIsotLuvut(tfVastaus.getText(), isoLukuSystem,
					system); // Huomauta niiden koosta
			if (!txt.isEmpty())
				System.out.println(txt);
			// System.out.println("uusiOperandi(lopussa): vastausDesimaali:"
			// + vastausDesimaali + ", desimaali:" + desimaali);
			// System.out.println("uusiOperandi lopussa: edellinen:" +
			// edellinen);
			edellinen = emptyString;
			tfLuku.setText(emptyString);
			tfLuku.requestFocus();
		} else {
			String virheteksti = error10;
			System.out.println(virheteksti);
			naytaVirheilmoitus(virheteksti, errorHeading);
		}
	}
	
	private void elapsedTime(boolean start){
		
		TimeZone tz = TimeZone.getTimeZone("GMT+03:00");
		if (start){
			cal1 = Calendar.getInstance(tz);
			startT = cal1.getTimeInMillis();
		}else{
			cal2 = Calendar.getInstance(tz);
			stopT = cal2.getTimeInMillis();
			
			double diffSecs = (startT) / 1000.;
			int ss = (int)diffSecs % 60;
			int mm = (int)((diffSecs - ss) / 60) % 60;
			int hh = (int)((diffSecs / 3600) % 24);
			Formatter f = new Formatter();
			f.format("%02d:%02d:%02d", hh, mm, ss);
			String startTime = f.toString();
			
			diffSecs = (stopT - startT) / 1000.;
			int ms = (int)(diffSecs - (int)diffSecs); // decimals only
			int ss2 = (int)diffSecs % 60;
			int mm2 = (int)((diffSecs - ss) / 60) % 60;
			int hhh2 = (int)(diffSecs / 3600);
			Formatter f2 = new Formatter();
			f2.format("%03d:%02d:%02d,%03d", hhh2, mm2, ss2, ms);
			String elapsed = f2.toString();
			System.out.println("\nstart time: " + startTime + ", start ms: " + startT + ", stop ms: " + stopT + " elapsed time: " + elapsed);
			
			lbTime.setText(elapsed);
			start = false;
		}
	}

	private BigDecimal toJavaDP(String in) {
		// System.out.println("'" + changeDP(in, defaultDP, javaDP) + "'");
//		System.out.println("toJavaDP: in: " + in + " defaultDP: " + defaultDP
//				+ " javaDP: " + javaDP);
		BigDecimal out = new BigDecimal(changeDP(in, defaultDP, javaDP)); // vaihtaa
		// defaultDP:n
		// javaDP:ksi
		return out;
	}

	private String toDefaultDP(BigDecimal in) {
		String out = changeDP(in.toString(), javaDP, defaultDP); // vaihtaa
		// javaDP:n
		// defaultDP:ksi
		return out;
	}

	private String toDefaultDP(BigInteger in) {
		String out = changeDP(in.toString(), javaDP, defaultDP); // vaihtaa
		// javaDP:n
		// defaultDP:ksi
		return out;
	}

	private String changeDP(String in, String vaihdaIn, String vaihdaOut) {
		String apu = in;
//		System.out.println("changeDP: in:" + in);
		if (!defaultDP.equals(javaDP)) {
			apu = in + "  ";
			int dp = apu.indexOf(vaihdaIn);
			// System.out.println("changeDP:dp:" + dp);
			if (dp != -1) {
				String left = apu.substring(0, dp);
				String right = apu.substring(dp + 1);
				apu = left + vaihdaOut + right;
			}
		}
		// System.out.println("changeDP:apu:" + apu);
		return apu.trim();
	}

	private String muotoileDesimaali(BigDecimal bd) {
		/**
		 * Always count by full precision, but call finalizeAnswer in laske()
		 */
		String palauta = emptyString;
		if (engineering) {
			palauta = bd.toEngineeringString();
		} else {
			palauta = bd.toString();
			// System.out.println("muotoileDesimaali: " + palauta);
		}
		palauta = changeDP(palauta, javaDP, defaultDP);
		return palauta;
	}

	private String finalizeDecimalAnswer(String dvastaus) {
		/**
		 * Always count by full precision but convert final answer to wanted
		 * precision
		 */
		// System.out.println("finalizeDecimalAnswer: " + dvastaus);
		if (maxDecimals.equals("max") || dvastaus.equals(infinity)) {
			// do nothing
		} else {
			int h = 0;
			try {
				h = Integer.parseInt(maxDecimals);
			} catch (Exception e) {
				e.printStackTrace();
				System.exit(1); // programming error
			}
			double decimals = (double) h;
			decimals = Math.pow(10, decimals);
			BigDecimal round = new BigDecimal(decimals);
			BigDecimal bd = toJavaDP(dvastaus);
			// System.out.println("round:" + round + " bd 1:" + bd);
			bd = bd.multiply(round);
			// System.out.println("bd 2:" + bd);
			BigDecimal up = new BigDecimal(0.5);
			BigDecimal down = new BigDecimal(-0.5);
			if (bd.compareTo(new BigDecimal(0)) == -1) { // is it negative?
				bd = bd.add(down); // yes, negative
				// System.out.println("negative bd 3:" + bd);
			} else {
				bd = bd.add(up); // positive
				// System.out.println("positive bd 4:" + bd);
			}
			int dp = bd.toString().indexOf(javaDP);
			BigInteger bi = new BigInteger(bd.toString().substring(0, dp));
			// System.out.println("decimalpoint index: " + dp + " bi:" + bi +
			// " round:" + round);
			bd = new BigDecimal(bi);
			bd = bd.divide(round); // convert back to decimal
			dvastaus = changeDP(bd.toString(), javaDP, defaultDP);
			tfVastaus.setText(dvastaus);
		}
		return dvastaus;
	}

	private String naytaIsotLuvut(String luku, int luvunpituus, String target) {
		// returns either the number itself or its long formatted form starting
		// with ="dataline..."

		// target = "system" tai "loki"
//		System.out.println("Luku: " + luku + " luvunpituus: " + luvunpituus
//				+ " target:" + target);
//		System.out.println("naytaIsotLuvut: luku: " + luku);
		if (answering && vastausDesimaali) { // coming from calc button push
//			System.out.println("naytaIsotLuvut: luku: " + luku + " finalizing");
			luku = finalizeDecimalAnswer(luku);
		}
		String palauta = "";
		int etumerkki = 0;
		String v = luku;
		if (v.substring(0, 0).equals(minusSign))
			etumerkki = 1;
		int desimaaliPiste = 0;
		int p = 1;
		if (v.contains(defaultDP)) {
			desimaaliPiste = 1;
			p--;
		}
		int vastauksenPituus = v.length();
		int exponent = v.indexOf(exponentSign);
		if (exponent > -1) {
			// boolean exponentSign = false;
			if (v.substring(exponent, exponent + 1).equals(plusSign)) {
				// exponentSign = true;
				palauta += "plusSign: " + v.substring(exponent, exponent + 1);
			}
			palauta += vastauksenPituus + " " + exponent;
		}
		int kokonaisOsa = v.indexOf(defaultDP) + p - etumerkki;
		int desimaaliOsa = vastauksenPituus - kokonaisOsa - desimaaliPiste
				- etumerkki;
		if (v.indexOf(defaultDP) == -1) {
			desimaaliOsa = 0;
			kokonaisOsa = vastauksenPituus - etumerkki;
		}
		String ilmoitus = txt13 + kokonaisOsa + defaultDP + desimaaliOsa
				+ txt14;
		if (target.equals(loki) && (kokonaisOsa + desimaaliOsa) > luvunpituus) // ollut
			// 33
			naytaVirheilmoitus(ilmoitus, obsHeading); // vain huomautus, ei
		// virhe
		// if (kokonaisOsa + desimaaliOsa > luvunpituus) {
		// int naytaIsotLuvutRivinPituus = 4;
		// palauta = backSlashN + palauta; // start long number in new line
		if (target.equals(system)) {
			palauta += rivPit + naytaIsotLuvutRivinPituus + backSlashN;
		} else {
			palauta += lokiPit + naytaIsotLuvutLokiPituus + backSlashN;
		}

		palauta += txt15 + ilmoitus;
		int line = -1;
		int rmax;
		if (target.equals(system)) {
			for (int i = 0; i < vastauksenPituus; i += naytaIsotLuvutRivinPituus) {

				line++;
				DecimalFormat df = new DecimalFormat("0000");
				int a = (line + 1) * naytaIsotLuvutRivinPituus;
				rmax = Math.min(a, vastauksenPituus);
				// System.out.println(i + " " + a + " " +
				// naytaIsotLuvutRivinPituus + " " + vastauksenPituus);
				palauta += backSlashN + df.format(line) + ": "
						+ v.substring(i, rmax); // tulosta rivi
				// kerrallaan

				// System.out.println("rmax:" + rmax + " line:" + line +
				// " naytaIsotLuvutRivinPituus:" + naytaIsotLuvutRivinPituus);
			}
		} else { // "loki"

			for (int i = 0; i < vastauksenPituus; i += naytaIsotLuvutLokiPituus) {
				line++;
				DecimalFormat df = new DecimalFormat("0000");
				int a = (line + 1) * naytaIsotLuvutLokiPituus;
				rmax = Math.min(a, vastauksenPituus);
				// System.out.println(i + " " + a + " " +
				// naytaIsotLuvutLokiPituus + " " + vastauksenPituus);
				palauta += backSlashN + df.format(line) + ": "
						+ v.substring(i, rmax);
				// kerrallaan
				// System.out.println("rmax:" + rmax + " line:" + line +
				// " naytaIsotLuvutLokiPituus:" + naytaIsotLuvutLokiPituus);
			}
		}
		// }
		// System.out.println(target + " " + luvunpituus + " " + (kokonaisOsa +
		// desimaaliOsa));
		if (kokonaisOsa + desimaaliOsa <= isoLukuSystem
				&& target.equals(system)) {
			palauta = luku;
		}
		if (((kokonaisOsa + desimaaliOsa) <= isoLukuLoki)
				&& target.equals(loki)) {
			palauta = luku;
		}
//		System.out.println("naytaIsotLuvut: palauta:'" + palauta + "'");
		return palauta;
	}

	private void teeNayttoWindows() {
		Dimension btnDimN = new Dimension(60, 29);
		Box box1 = Box.createHorizontalBox(); // luku/liita
		Box box1Label = Box.createHorizontalBox();
		box1Label.setBorder(BorderFactory.createEmptyBorder(2, 11, 2, 2));
		Box box1Luku = Box.createHorizontalBox();
		box1Luku.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		Box box1Liita = Box.createHorizontalBox();
		box1Liita.setBorder(BorderFactory.createEmptyBorder(2, 31, 2, 2));
		Box box2 = Box.createHorizontalBox(); // vastaus/kopioi
		Box box2Label = Box.createHorizontalBox();
		box2Label.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		Box box2Vastaus = Box.createHorizontalBox();
		box2Vastaus.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		Box box2Kopioi = Box.createHorizontalBox();
		box2Kopioi.setBorder(BorderFactory.createEmptyBorder(2, 30, 2, 2));
		Box box3 = Box.createHorizontalBox(); // loki textarea/kopioi
		Box box4 = Box.createHorizontalBox(); // nappaimet (1,2,3)
		Box box5 = Box.createHorizontalBox(); // nappaimet (4,5,6)
		Box box6 = Box.createHorizontalBox(); // nappaimet (7,8,9)
		Box box7 = Box.createHorizontalBox(); // nappaimet (+/-,0,.)
		// (0,+/-,desimaalipiste,potenssi)
		Box box7a = Box.createHorizontalBox(); // max decimals combo box
		Box box8 = Box.createHorizontalBox(); // nappaimet
		// (laske,CLEAR,#V,lopeta)
		Box box9 = Box.createVerticalBox(); // laskut
		Box boxvasen = Box.createVerticalBox();

		box4.setBorder(BorderFactory.createEmptyBorder(2, 0, 1, 20)); // 1,2,3
		// Yla,vas,ala,oik
		box5.setBorder(BorderFactory.createEmptyBorder(2, 0, 1, 20)); // 4,5,6
		box6.setBorder(BorderFactory.createEmptyBorder(2, 0, 1, 20)); // 7,8,9
		box7.setBorder(BorderFactory.createEmptyBorder(2, 0, 1, 20));
		box8.setBorder(BorderFactory.createEmptyBorder(2, 0, 1, 55));
		box9.setBorder(BorderFactory.createEmptyBorder(0, 0, 1, 0)); // laskut

		lbLuku = new JLabel(txt16);
		lbVastaus = new JLabel(txt17);
		lbLuku.setMinimumSize(btnDim1);
		lbLuku.setMaximumSize(btnDim1);
		lbVastaus.setMinimumSize(btnDim1);
		lbVastaus.setMaximumSize(btnDim1);

		tfLuku = new JTextField(22);
		tfVastaus = new JTextField(22);
		tfLuku.setMinimumSize(btnDim2);
		tfLuku.setMaximumSize(btnDim2);
		tfVastaus.setMinimumSize(btnDim2);
		tfVastaus.setMaximumSize(btnDim2);

		taLoki = new JTextArea();
		jscrlp = new JScrollPane(taLoki); // horisonttaali ja vertikaali
		// vierityspalkit automaattisesti
		jscrlp.setPreferredSize(new Dimension(330, 140)); // leveys, korkeus
		taLoki.setText(log);
		taLoki.setLineWrap(true); // ei horisonttaali vierityspalkkia, vain
		// vertikaali
		taLoki.setWrapStyleWord(true); // line wrap kokonaisten sanojen kohdalta

		btLiita = new JButton(liita);
		btKopioi1 = new JButton(kopioi);
		btKopioi2 = new JButton(kopioi);

		btYksi = new JButton(one);
		Box box41 = Box.createHorizontalBox();
		box41.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		box41.setMinimumSize(btnDimN);
		box41.setMaximumSize(btnDimN);
		box4.add(box41);

		btKaksi = new JButton(two);
		Box box42 = Box.createHorizontalBox();
		box42.setBorder(BorderFactory.createEmptyBorder(2, 9, 2, 2));
		box42.setMinimumSize(btnDimN);
		box42.setMaximumSize(btnDimN);
		box4.add(box42);

		btKolme = new JButton(three);
		Box box43 = Box.createHorizontalBox();
		box43.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		box43.setMinimumSize(btnDimN);
		box43.setMaximumSize(btnDimN);
		box4.add(box43);

		btNelja = new JButton(four);
		Box box54 = Box.createHorizontalBox();
		box54.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		box54.setMinimumSize(btnDimN);
		box54.setMaximumSize(btnDimN);
		box5.add(box54);

		btViisi = new JButton(five);
		Box box55 = Box.createHorizontalBox();
		box55.setBorder(BorderFactory.createEmptyBorder(2, 9, 2, 2));
		box55.setMinimumSize(btnDimN);
		box55.setMaximumSize(btnDimN);
		box5.add(box55);

		btKuusi = new JButton(six);
		Box box56 = Box.createHorizontalBox();
		box56.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		box56.setMinimumSize(btnDimN);
		box56.setMaximumSize(btnDimN);
		box5.add(box56);

		btSeitseman = new JButton(seven);
		Box box67 = Box.createHorizontalBox();
		box67.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		box67.setMinimumSize(btnDimN);
		box67.setMaximumSize(btnDimN);
		box6.add(box67);

		btKahdeksan = new JButton(eight);
		Box box68 = Box.createHorizontalBox();
		box68.setBorder(BorderFactory.createEmptyBorder(2, 9, 2, 2));
		box68.setMinimumSize(btnDimN);
		box68.setMaximumSize(btnDimN);
		box6.add(box68);

		btYhdeksan = new JButton(nine);
		Box box69 = Box.createHorizontalBox();
		box69.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		box69.setMinimumSize(btnDimN);
		box69.setMaximumSize(btnDimN);
		box6.add(box69);

		btVaihda = new JButton(plusMinus);
		Box boxVaihda = Box.createHorizontalBox();
		boxVaihda.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		boxVaihda.setMinimumSize(btnDimN);
		boxVaihda.setMaximumSize(btnDimN);
		box7.add(boxVaihda);

		btNolla = new JButton(zero);
		Box box70 = Box.createHorizontalBox();
		box70.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		box70.setMinimumSize(btnDimN);
		box70.setMaximumSize(btnDimN);
		box7.add(box70);

		btDesim = new JButton(defaultDP); // desimaalipiste
		Box boxD = Box.createHorizontalBox();
		boxD.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		boxD.setMinimumSize(btnDimN);
		boxD.setMaximumSize(btnDimN);
		box7.add(boxD);

		Dimension btnLaskut = new Dimension(120, 29);
		btSumma = new JButton(sum);
		Box boxSumma = Box.createHorizontalBox();
		boxSumma.setBorder(BorderFactory.createEmptyBorder(0, 2, 2, 2));
		boxSumma.setMinimumSize(btnLaskut);
		boxSumma.setMaximumSize(btnLaskut);
		box9.add(boxSumma);
		btTulo = new JButton(multiplication);
		Box boxMul = Box.createHorizontalBox();
		boxMul.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		boxMul.setMinimumSize(btnLaskut);
		boxMul.setMaximumSize(btnLaskut);
		box9.add(boxMul);
		btJako = new JButton(dividation);
		Box boxDiv = Box.createHorizontalBox();
		boxDiv.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		boxDiv.setMinimumSize(btnLaskut);
		boxDiv.setMaximumSize(btnLaskut);
		box9.add(boxDiv);
		btPotenssi = new JButton(powText);
		Box boxPow = Box.createHorizontalBox();
		boxPow.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		boxPow.setMinimumSize(new Dimension(120, 38));
		boxPow.setMaximumSize(new Dimension(120, 38));
		box9.add(boxPow);
		btLaske = new JButton(calculate);
		btLaske.setMinimumSize(btnDim5);
		btLaske.setMaximumSize(btnDim5);
		btClear = new JButton("Tyhjennä");
		btClear.setMinimumSize(btnDim4);
		btClear.setMaximumSize(btnDim4);
		btV = new JButton(numberAnswer);
		btV.setMinimumSize(btnDim3);
		btV.setMaximumSize(btnDim3);
		btLopeta = new JButton("Lopeta");
		btLopeta.setMinimumSize(btnDim4);
		btLopeta.setMaximumSize(btnDim4);
		lbMaxDecimals = new JLabel(decimalsText);
		cbMaxDecimals = new JComboBox(maxDecimalsTable);

		btLaske.setToolTipText(tip1);
		btVaihda.setToolTipText(tip2);

		box1Label.add(lbLuku);
		// box1.add(Box.createRigidArea(new Dimension(0, 10))); // lisataan
		// korkeussuunnassa
		// pixeleita(Vertical)yla ja alapuolelle
		box1Luku.add(tfLuku);
		box1Liita.add(btLiita);

		box1.add(box1Label);
		box1.add(box1Luku);
		box1.add(box1Liita);

		box2Label.add(lbVastaus);
		box2Vastaus.add(tfVastaus);
		box2Kopioi.add(btKopioi1);

		box2.add(box2Label);
		box2.add(box2Vastaus);
		box2.add(box2Kopioi);

		box3.add(jscrlp);
		box3.add(btKopioi2);

		// lisataan alkuun vasemmalle pixeleita(Horizontal)
		box4.add(Box.createRigidArea(new Dimension(10, 10)));
		box41.add(btYksi);
		box42.add(btKaksi);
		box43.add(btKolme);
		// box4.add(btSumma);

		box5.add(Box.createRigidArea(new Dimension(10, 10)));
		box54.add(btNelja);
		box55.add(btViisi);
		box56.add(btKuusi);
		// box5.add(btTulo);

		box6.add(Box.createRigidArea(new Dimension(10, 0)));
		box67.add(btSeitseman);
		box68.add(btKahdeksan);
		box69.add(btYhdeksan);
		// box6.add(btJako);

		box7.add(Box.createRigidArea(new Dimension(10, 0)));
		boxVaihda.add(btVaihda);
		box70.add(btNolla);
		boxD.add(btDesim);
		// box7.add(btPotenssi);

		box7a.add(lbMaxDecimals);
		box7a.add(Box.createRigidArea(new Dimension(10, 0)));
		box7a.add(cbMaxDecimals);
		box7a.add(Box.createRigidArea(new Dimension(30, 0)));
		cbMaxDecimals.setMaximumRowCount(12);

		box8.add(Box.createRigidArea(new Dimension(10, 0)));
		box8.add(btLaske);
		box8.add(btClear);
		box8.add(btV);
		box8.add(btLopeta);

		boxSumma.add(btSumma);
		boxMul.add(btTulo);
		boxDiv.add(btJako);
		boxPow.add(btPotenssi);

		naytto.add(box1); // Luku
		naytto.add(box2); // Vastaus
		naytto.add(box3); // loki
		boxvasen.add(box4); // 1,2,3
		boxvasen.add(box5); // 4,5,6
		boxvasen.add(box6); // 7,8,9
		boxvasen.add(box7); // +/-,0,.
		naytto.add(boxvasen); // numerot
		// naytto.add(box4);
		naytto.add(box9); // summa, Tulo, Jako, Potenssi
		// naytto.add(box5);
		// naytto.add(box6);
		// naytto.add(box7);
		naytto.add(box7a);
		naytto.add(box8);

	} // teeNayttoWindows

	private void teeNayttoMac() {

		Box box1 = Box.createHorizontalBox(); // luku/liita
		Box box2 = Box.createHorizontalBox(); // vastaus/kopioi
		Box box3 = Box.createHorizontalBox(); // loki textarea/kopioi
		Box box4 = Box.createHorizontalBox(); // nappaimet (1,2,3,summa)
		Box box5 = Box.createHorizontalBox(); // nappaimet (4,5,6,tulo)
		Box box6 = Box.createHorizontalBox(); // nappaimet (7,8,9,jako)
		Box box7 = Box.createHorizontalBox(); // nappaimet
		// (0,+/-,desimaalipiste,potenssi)
		Box box7a = Box.createHorizontalBox(); // max decimals combo box
		Box box8 = Box.createHorizontalBox(); // nappaimet
		// (laske,CLEAR,V#,lopeta)
		
		Box box9 = Box.createHorizontalBox(); // elapsed time in pow

		lbLuku = new JLabel("  Luku :");
		lbVastaus = new JLabel("Vastaus :  ");

		tfLuku = new JTextField(22);
		tfVastaus = new JTextField(22);
		btLiita = new JButton(liita);
		btKopioi1 = new JButton(kopioi);
		btKopioi2 = new JButton(kopioi);

		taLoki = new JTextArea();
		jscrlp = new JScrollPane(taLoki); // horisonttaali ja vertikaali
		// vierityspalkit automaattisesti
		jscrlp.setPreferredSize(new Dimension(335, 140)); // leveys, korkeus
		// taLoki.setText("loki");
		taLoki.setLineWrap(true); // ei horisonttaali vierityspalkkia, vain
		// vertikaali
		taLoki.setWrapStyleWord(true); // line wrap kokonaisten sanojen kohdalta

		btYksi = new JButton("1");
		btYksi.setMinimumSize(btnDim3);
		btYksi.setMaximumSize(btnDim3);
		btKaksi = new JButton("2");
		btKaksi.setMinimumSize(btnDim3);
		btKaksi.setMaximumSize(btnDim3);
		btKolme = new JButton("3");
		btKolme.setMinimumSize(btnDim3);
		btKolme.setMaximumSize(btnDim3);
		btNelja = new JButton("4");
		btNelja.setMinimumSize(btnDim3);
		btNelja.setMaximumSize(btnDim3);
		btViisi = new JButton("5");
		btViisi.setMinimumSize(btnDim3);
		btViisi.setMaximumSize(btnDim3);
		btKuusi = new JButton("6");
		btKuusi.setMinimumSize(btnDim3);
		btKuusi.setMaximumSize(btnDim3);
		btSeitseman = new JButton("7");
		btSeitseman.setMinimumSize(btnDim3);
		btSeitseman.setMaximumSize(btnDim3);
		btKahdeksan = new JButton("8");
		btKahdeksan.setMinimumSize(btnDim3);
		btKahdeksan.setMaximumSize(btnDim3);
		btYhdeksan = new JButton("9");
		btYhdeksan.setMinimumSize(btnDim3);
		btYhdeksan.setMaximumSize(btnDim3);
		btNolla = new JButton("0");
		btNolla.setMinimumSize(btnDim3);
		btNolla.setMaximumSize(btnDim3);
		btVaihda = new JButton("+/-");
		btVaihda.setMinimumSize(btnDim3);
		btVaihda.setMaximumSize(btnDim3);
		btDesim = new JButton(defaultDP); // desimaalipiste
		btDesim.setMinimumSize(btnDim3);
		btDesim.setMaximumSize(btnDim3);

		btSumma = new JButton("Summa");
		btTulo = new JButton("Tulo");
		btJako = new JButton("Jako");
		btPotenssi = new JButton("Potenssi");
		btLaske = new JButton("Laske");
		btLaske.setMinimumSize(btnDim5);
		btLaske.setMaximumSize(btnDim5);
		btClear = new JButton("Tyhjennä");
		btClear.setMinimumSize(btnDim6);
		btClear.setMaximumSize(btnDim6);
		btV = new JButton(numberAnswer);
		btV.setMinimumSize(btnDim3);
		btV.setMaximumSize(btnDim3);
		btLopeta = new JButton("Lopeta");
		btLopeta.setMinimumSize(btnDim5);
		btLopeta.setMaximumSize(btnDim5);
		lbMaxDecimals = new JLabel(decimalsText);
		cbMaxDecimals = new JComboBox(maxDecimalsTable);
		
		lbTimeHdr = new JLabel(timeHdr);
		lbTime = new JLabel(timeTxt);

		box1.add(lbLuku);
		box1.add(Box.createRigidArea(new Dimension(10, 10))); // lisataan
		// korkeussuunnassa
		// pixeleita(Vertical)
		box1.add(tfLuku);
		box1.add(btLiita);

		box2.add(lbVastaus);
		box2.add(tfVastaus);
		box2.add(btKopioi1);

		box3.add(jscrlp);
		box3.add(btKopioi2);

		// lisataan alkuun vasemmalle pixeleita(Horizontal)
		box4.add(Box.createRigidArea(new Dimension(15, 0)));
		box4.add(btYksi);
		box4.add(btKaksi);
		box4.add(btKolme);
		box4.add(btSumma);

		box5.add(Box.createRigidArea(new Dimension(0, 0)));
		box5.add(btNelja);
		box5.add(btViisi);
		box5.add(btKuusi);
		box5.add(btTulo);

		box6.add(Box.createRigidArea(new Dimension(0, 0)));
		box6.add(btSeitseman);
		box6.add(btKahdeksan);
		box6.add(btYhdeksan);
		box6.add(btJako);

		box7.add(Box.createRigidArea(new Dimension(23, 0)));
		box7.add(btVaihda);
		box7.add(btNolla);
		box7.add(btDesim);
		box7.add(btPotenssi);

		box7a.add(Box.createRigidArea(new Dimension(0, 0)));
		box7a.add(lbMaxDecimals);
		box7a.add(cbMaxDecimals);
		cbMaxDecimals.setMaximumRowCount(12);

		box8.add(Box.createRigidArea(new Dimension(25, 0)));
		box8.add(btLaske);
		box8.add(btClear);
		box8.add(btV);
		box8.add(btLopeta);
		
		box9.add(lbTimeHdr);
		box9.add(lbTime);

		naytto.add(box1);
		naytto.add(box2);
		naytto.add(box3);
		naytto.add(box4);
		naytto.add(box5);
		naytto.add(box6);
		naytto.add(box7);
		naytto.add(box7a);
		naytto.add(box8);
//		naytto.add(box9);

	} // end teeNayttoMac

	Container naytto;

	JButton btVersion; // dummy button, shows program version alt,V

	Dimension btnDim1 = new Dimension(60, 25); // leveys,korkeus
	JLabel lbLuku;
	JLabel lbVastaus;

	Dimension btnDim2 = new Dimension(260, 25);
	JTextField tfLuku;
	JTextField tfVastaus;

	JTextArea taLoki;
	JScrollPane jscrlp;

	Dimension btnDim3 = new Dimension(50, 25);
	JButton btYksi;
	JButton btKaksi;
	JButton btKolme;
	JButton btNelja;
	JButton btViisi;
	JButton btKuusi;
	JButton btSeitseman;
	JButton btKahdeksan;
	JButton btYhdeksan;
	JButton btNolla;
	JButton btDesim;

	Dimension btnDim4 = new Dimension(80, 25);
	JButton btSumma;
	JButton btTulo;
	JButton btJako;
	JButton btVaihda;
	JButton btPotenssi;

	JLabel lbMaxDecimals;
	JComboBox cbMaxDecimals;
	private String[] maxDecimalsTable = { "0", "1", "2", "3", "4", "5", "6",
			"7", "8", "9", "10", "max" };

	Dimension btnDim5 = new Dimension(70, 25);
	Dimension btnDim6 = new Dimension(90, 25);
	JButton btLaske;
	JButton btClear;
	JButton btV;
	JButton btLopeta;
	JButton btKopioi1;
	JButton btKopioi2;
	JButton btLiita;
	
	JLabel lbTimeHdr;
	JLabel lbTime;

	private ArrayList<String> vastaukset; // kaikki ajon vastaukset, Laske
	// nappain
	private BigInteger luku; // syotetty luku
	private String dluku; // syotetty desimaaliluku
	private BigInteger vastaus; // tahanastinen vastaus (BigInteger)
	// private BigInteger vastausSave;
	private String dvastaus; // tahanastinen vastaus (BigDecimal)
	// private BigDecimal dvastausSave;
	private int pow; // potenssi [0 - 999999999]
	private boolean engineering; // ei kaytossa
	private boolean nappaimet; // false, jos tiedon sisaansyottonappaimet eivat
	// kaytossa
	private boolean vastausDesimaali; // true, jos vastaus desimaalilukuna
	// private boolean vastausDesimaaliSave;
	private boolean desimaali; // true, jos syotettava luku desimaaliluku
	private String edellinen; // edellinen ok syotetty (d)luku
	private boolean alku = true; // ohjelman alku alkaa lokissa
	private int laskuja;
	private int edellinenOperandi; // 1=summa,2=tulo,3=jako,4=potenssi, 5=#V

	private String defaultDP = "."; // desimaalipiste
	private String javaDP = ".";

	private String yhteenveto;
	private TextTransfer leikepoyta;
	private boolean pysyvaTarkkuus;
	final MathContext DECIMAL128 = MathContext.DECIMAL128; // max 34 desimaalin
	// tarkkuus
	private boolean lukuSyotetty; // true kun lueLuku():ssa ok numero/luku
	// private boolean sisaansyotto; // false, jos tiedon sisaansyotto estetty
	// nappaimilta ja tfLuku
	private boolean operaatiot; // false, jos operaationappainten toiminta
	// estetty
	private String vastausInd = "";
	private boolean referOk; // is true when referred to prev answer till log
	private String version;
	private String maxDecimals;
	private boolean answering; // true if just calc has selected
	private String dataline = "dataline"; // same in english and finnish
//	private long startTimeMs; // time in ms when counting pow
	private static long  startT = Calendar.getInstance().getTimeInMillis();
	private static long  stopT = Calendar.getInstance().getTimeInMillis();
	private static TimeZone tz = TimeZone.getTimeZone("GMT+03:00");
	private static Calendar cal1 = Calendar.getInstance(tz);
	private static Calendar cal2;
	
	/**
	 * Convertable texts
	 */
	private String language = "fi";
	private String function = "suurten lukujen peruslaskin";
	// private final String txt0 =
	// "Laheta luku painamalla enter-nappainta nappaimistollasi.";
	private final String txt1 = "Voit vahentaa, kun vaihdat luvun etumerkkia.";
	private final String txt2 = "DECIMAL128 rajoitus jakolaskussa(34 desimaalia).";
	private final String txt3 = "Voit viitata edellisiin vastauksiin, kun annat vastauksen numeron ja klikkaat tata nappulaa, viimeisin vastaus on aina indeksilla 0.";
	private final String txt4 = "Nappaile ensin korotettava luku. Sitten tama nappain. Vain kokonaisluku potenssit sallitaan.";
	private final String txt6 = "Tyhjentaa lokin ja nollaa muuttujat paitsi voit viitata viela edellisiin vastauksiin.";
	private final String txt7 = "Koko laskutoimitus loki voidaan jattaa leikepoydalle lopetettaessa.";
	private final String programName = "FrLaskin:";
	private final String lastIndex = "0";
	private final String emptyString = "";
	private final String summary = "\n____________________\n";
	private final String error1 = "Vain kokonaisluku potenssi sallittu!";
	private final String header1 = "Desimaalipiste hylatty";
	private final String out1 = "Palautettu luku: ";
	private final String one = "1";
	private final String two = "2";
	private final String three = "3";
	private final String four = "4";
	private final String five = "5";
	private final String six = "6";
	private final String seven = "7";
	private final String eight = "8";
	private final String nine = "9";
	private final String zero = "0";
	private final String hyphen = "-";
	private final String minusOne = "-1";
	private final String txt8 = "Sovellus loppuu, sailytetäänko viimeisin loki leikepoydällä?";
	private final String txt9 = "Leikepöytä tyhjennetty!\nSovellus päättyy!";
	private final String txt10 = "Leikepöytä säilytetään, sovellus loppuu!";
	private final String txt11 = "Cancel/Closed option Lopeta napilla, suoritus jatkuu.";
	private final String minusSign = "-";
	private final String error2 = "Vain kokonaisluku potenssi sallittu!";
	private final String header2 = "Desimaalipiste hylätty";
	private final String error3 = "Vain potenssi välillä [0 - 999999999] sallittu!";
	private final String header3 = "Potenssi virhe";
	private final String error4 = "Luvun muunto potenssiksi [0-999999999] epäonnistui: ";
	private final String errorHeading = "virhe";
	private final String error5 = "Luvun esitysmuotovirhe: ";
	private final String error6 = "Luvun esitysmuotovirhe:";
	private final String errorPow = "Potenssi voi olla vain valiltä [0 - 999999999]! : ";
	private final String answer = "V#";
	private final String answer1 = "   V#";
	private final String txt12 = "Näppäile uudelleen oikea vastausnumero(ehkä vastaus on kielletty desimaalipotenssi)! Viimeisin vastaus on aina 0:";
	private final String infinity = "infinity";
	private final String error7 = "palautaVastaus(): Viittaa vain numeerisiin vastauksiin!\nNäppäile uudelleen!";
	private final String question1 = "Anna maksimi desimaalien lukumäärä vastauksessa:";
	private final String question1Heading = "Jos negatiivinen, niin pysyvästi ohjelman ajan:";
	private final String out2 = "kysyLaskutoimitustenTarkkuus: virheellinen vastaus: ";
	private final String backSlashN = "\n";
	private final String space = " ";
	private final String addOperator = " + ";
	private final String equalSign = " = ";
	private final String multiplicationOperator = " * ";
	private final String dividationOperator = " / ";
	private final String error8 = "ylläolevassa laskutoimituksessa AritmeticException!";
	private final String error8Plus = "Esimerkiksi vastaus olisi päättyäatön luku.";
	private final String errorPow2 = "ylläolevassa laskutoimituksessa AritmeticException!";
	private final String errorPowPlus2 = "yritä pienentää absoluuttisesti joko lukua tai potenssia.";
	private final String powOperator = "^";
	private final String error9 = "*********************** Sovellusvirhe: Operandeja enemmän kuin pitäisi eli ei 0 - 4: ";
	private final String error10 = "Edellinen luku virheellinen!";
	private final String txt13 = "Vastauksen pituus merkkeinä: kokonaisosa.desimaaliosa: ";
	private final String txt14 = " numeroa";
	private final String obsHeading = "HUOM!";
	private final String txt15 = "naytaIsotLuvut: ";
	private final String txt16 = "Luku: ";
	private final String txt17 = "Vastaus: ";
	private final String log = "loki";
	private final String plusMinus = "+/-";
	private final String sum = "Summa";
	private final String multiplication = "Tulo";
	private final String dividation = "Jako";
	private final String powText = "Potenssi";
	private final String calculate = "Laske";
	private final String numberAnswer = "#V";
	private final String tip1 = "Suorittaa laskut vasemmalta oikealle ilman normaaleja laskujärjestyksiä";
	private final String tip2 = "Vaihtaa etumerkin";
	private String tip8 = "Kaikki laskutoimitukset maximi tarkkuudella, mutta vastaus valitsemallasi tarkkuudella.";
	private final String colon = ": ";
	private final String exponentSign = "E";
	private final String plusSign = "+";
	private final String system = "sys"; // Tulostetaan System.out.print isot
	// luvut
	private final String loki = "loki"; // Tulostetaan lokiin isot luvut
	private final String liita = "Liitä";
	private final String kopioi = "Kopioi";
	private final int naytaIsotLuvutRivinPituus = 100; // isot luvut jaetaan
	// tulostuksessa
	// tasapituisiin
	// riveihin
	private final int naytaIsotLuvutLokiPituus = 30; // isot luvut tulostus
	// lokissa
	private final int isoLukuLoki = 35; // ison luvun pituus >
	private final int isoLukuSystem = 100; // ison luvun pituus >
	// private final String rivPit = "datarivin pituus: ";
	private final String rivPit = "dataline length: ";
	// private final String lokiPit = "datarivin pituus: ";
	private final String lokiPit = "dataline length: ";
	private final String instruction = "Voit syöttää luvut 2:lla tavalla: Joko valitsemalla numeronäppäimiä tai "
			+ "kirjoittamalla luku "
			+ txt16
			+ " ikkunaan ja lähettämällä se ohjelmalle "
			+ "painamalla enter-näppäintä näppaimistölläsi. \nVoit viitata edellisiin vastauksiin valitsemalla sen indeksi ja "
			+ "sen jalkeen "
			+ numberAnswer
			+ "-nappula.\nViimeisimpään vastaukseen voit aina viitata indeksillä 0.";
	private final String decimalsText = "Max desimaalien lkm vastauksessa: ";
	private final String timeHdr = "kulunut aika potenssilaskussa: ";
	private final String timeTxt = "ttt:mm:ss";

	public static void main(String[] args) {
		FrLaskin sovellus = new FrLaskin("FrLaskin:");
		sovellus.setVisible(true);

	}

}